"""Create Permission table

Revision ID: cafa1e01b782
Revises: 5521b5759004
Create Date: 2022-05-04 11:41:54.470870

"""

import sqlalchemy as sa
from alembic import op
from sqlalchemy.dialects import mysql

# revision identifiers, used by Alembic.
revision = "cafa1e01b782"
down_revision = "5521b5759004"
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table(
        "bucketpermission",
        sa.Column("user_id", sa.String(length=64), nullable=False),
        sa.Column("bucket_name", sa.String(length=63), nullable=False),
        sa.Column("from", sa.Integer(), nullable=True),
        sa.Column("to", sa.Integer(), nullable=True),
        sa.Column("file_prefix", sa.String(length=512), nullable=True),
        sa.Column("permissions", mysql.ENUM("READ", "WRITE", "READWRITE"), nullable=False),
        sa.ForeignKeyConstraint(["bucket_name"], ["bucket.name"], ondelete="CASCADE"),
        sa.ForeignKeyConstraint(["user_id"], ["user.uid"], ondelete="CASCADE"),
        sa.PrimaryKeyConstraint("user_id", "bucket_name"),
    )
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_table("bucketpermission")
    # ### end Alembic commands ###
